<?php
	class CallsController extends AppController{
		var $components = array('Recording','Session');

		function index(){
			$this->layout = 'recording';
			if(RECPASSWORD == null || RECUSER == null){
				$this->set('title_for_layout', 'Login Disabled');
				$this->set('header_for_layout', 'Login disabled please contact your Administrator');
				$this->view = 'nologin';
			}else{
				$this->set('title_for_layout', 'Login');
				$this->set('header_for_layout', 'Please login using your account credentials');
			}
		}

		function download($delete,$file = null){
			$this->layout = false;

			$domain = $this->Session->read('User.domain'); $username = $this->Session->read('User.username'); $password = $this->Session->read('User.managerpassword');
			$src = "$domain/recordings.php?username=$username&password=$password&action=download&file_id=";

			// if $file is null, we download the oldest 30 recordings
			if($file == null){
				$max = 30; // set maximum of downloadable soundfiles
				$filename = $username.'_recordings.zip';
				$this->set('content_type', 'application/zip');
				$this->set('filename', $filename);
				$files = $this->Recording->getListRecordings();
				$zipfiles = array(); // array of filenames to be added to zip archive
				// prepare files to add to zip archive
				$count = 0;
				foreach($files AS $file){
					$count++;
					if($count > $max) break;
					$new_src = $src.urlencode($file);
					$temp_filename = substr($file,strrpos($file,'__')+2).'_'.$username.'.wav';
					$f = fopen($temp_filename,'w');
					$file_content = $this->getUrlResults($new_src);
					fwrite($f,$file_content);
					fclose($f);
					$zipfiles[] = $temp_filename;
				}

				// create zip archive and add files to it
				$zip = new ZipArchive;
				$zip->open($filename, ZipArchive::CREATE);
				foreach($zipfiles as $zipfile){
				  $zip->addFile($zipfile);
				}
				$zip->close();

				// delete the created temp files
				foreach($zipfiles as $zipfile){
					unlink($zipfile);
				}
			}else{
				$max = 1;
				$filename = substr($file,strrpos($file,'__')+2).'_'.$username.'.wav';
				$this->set('content_type', 'audio/wave');
				$this->set('filename', $filename);
				$src .= urlencode($file);
				$file_content = $this->getUrlResults($src);
				$this->set('file',$file_content);
			}

			// delete on server if chosen to
			if($delete){
				if(!isset($files))
					$files = array($file); // if $files isn't set, we downloaded a single file

				$errors = array();
				$count = 0;
				foreach($files AS $file){
					$count++;
					if($count > $max) break;
					$src = "$domain/recordings.php?username=$username&password=$password&action=delete&file_id=".urlencode($file);
					$result = $this->getUrlResults($src);
					// if we get a return, we have an error
					if($result != '') $errors[] = $result;
				}
				$this->set('errors',$errors);
			}
		}

		function getUrlResults($src){
			$curl = curl_init($src);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
			$result = curl_exec($curl);
			curl_close($curl);
			return $result;
		}

		function recordings($date,$page = 1){
			$recordings = $this->Recording->getFiles($date,$page);
			$date_text = date('jS F Y', strtotime($date));
			$this->set('title_for_layout', "Recordings for $date_text");
			$this->set('header_for_layout', "Recordings for $date_text");
			$this->set('recordings',$recordings);
			$this->set('cur_date',$date);
			$this->set('cur_page',$page);
			$this->set('login',$this->Session->read('User.login'));
			$this->set('username',$this->Session->read('User.username'));
		}

		function logout(){
			$this->set('title_for_layout', 'Logging out');
			$this->set('header_for_layout', 'Please wait...');
			$this->Session->write('User.login',false);
			$this->Session->write('User.username','');
			$this->Session->write('User.secret','');
			$this->Session->write('User.managerpassword','');
			$this->Session->write('User.domain','');
		}
	}
?>
