<?php
	class RecordingComponent extends Component{
		var $components = array('Session');

		function getListRecordings($page){
			$domain = $this->Session->read('User.domain'); $username = $this->Session->read('User.username'); $password = $this->Session->read('User.managerpassword');
			$src = "$domain/recordings.php?username=$username&password=$password&action=index&page=$page";
			$curl = curl_init($src);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
			$recordings = json_decode(curl_exec($curl));
			curl_close($curl);

			$listing = array();
			foreach($recordings AS $recording){
				// trim the folder names seperated by ~
				$recording_data = substr($recording,strpos($recording,'~')+1); // first folder is username, which we don't need

				// get date and update $recording_data
				$date = substr($recording_data,0,strpos($recording_data,'~')); // second folder is the date
                                $month_year = date('F Y',strtotime($date));
                                if(!isset($listing[$month_year][$date])) $listing[$month_year][$date] = array();
                                $recording_data = substr($recording_data,strpos($recording_data,'~')+1);

                                // get the time
                                $time = str_replace('-',':',substr($recording_data,0,strpos($recording_data,'__')));
                                $recording_data = substr($recording_data,strpos($recording_data,'__')+2);

                                // get the "from extension"
                                $from = substr($recording_data,0,strpos($recording_data,'__'));
                                $recording_data = substr($recording_data,strpos($recording_data,'__')+2);

                                // get the "to extension"
                                $to = substr($recording_data,0,strpos($recording_data,'__'));
                                $recording_data = substr($recording_data,strpos($recording_data,'__')+2);

                                // next data are digits that we don't need
                                $recording_data = substr($recording_data,strpos($recording_data,'--')+2);

                                // get the duration
                                $duration = substr($recording_data,0,strpos($recording_data,'--')).' s';
                                if($duration == ' s') $duration = "N/A"; // the duration is still in testing phase, not implemented on servers yet
                                $recording_data = substr($recording_data,strpos($recording_data,'--')+2);

                                // get the size
                                $size = ceil($recording_data/1024); // turn bytes into kilobytes

                                // write data into array
                                $listing[$month_year][$date]['data'][] = array(
	                                'time' => $time,
                                        'from' => $from,
                                        'to' => $to,
                                        'duration' => $duration,
                                        'size' => "$size kB",
					'recording' => $recording);
                                if(!isset($listing[$month_year][$date]['totalsize'])) $listing[$month_year][$date]['totalsize'] = $size;
                                else $listing[$month_year][$date]['totalsize'] += $size;
			}

			return $listing;
		}

		function getFolders(){
			$domain = $this->Session->read('User.domain'); $username = $this->Session->read('User.username'); $password = $this->Session->read('User.managerpassword');
			$src = "$domain/recordings.php?username=$username&password=$password&action=getfolders";
			$curl = curl_init($src);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
			$folders = json_decode(curl_exec($curl));
			curl_close($curl);
			$result = array();
			foreach($folders AS $folder => $foldersize){
				$month = date('Y-m', strtotime($folder));
				if(!isset($result[$month])) $result[$month] = array();
				$result[$month][$folder] = $foldersize;
			}
			return $result;
		}

		function getFiles($date,$page){
			$domain = $this->Session->read('User.domain'); $username = $this->Session->read('User.username'); $password = $this->Session->read('User.managerpassword');
			$src = "$domain/recordings.php?username=$username&password=$password&action=getfiles&date=$date&page=$page";
			$curl = curl_init($src);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
			$files = json_decode(curl_exec($curl));
			curl_close($curl);

			$recordings = array();
			$recordings['count'] = $files->count;
			unset($files->count); // need to unset this index to avoid problems in the next foreach
			foreach($files AS $file){
				// file path (structure: path/date/time__from__to__digits__username.wav--duration--size)
				$filepath = str_replace('/','~',substr($file,0,strrpos($file,'__')));
				$file_data = substr($file,strrpos($file,'/')+1);

                                // get the time
                                $time = str_replace('-',':',substr($file_data,0,strpos($file_data,'__')));
                                $file_data = substr($file,strpos($file,'__')+2);

                                // get the "from extension"
                                $from = substr($file_data,0,strpos($file_data,'__'));
                                $file_data = substr($file_data,strpos($file_data,'__')+2);

                                // get the "to extension"
                                $to = substr($file_data,0,strpos($file_data,'__'));
                                $file_data = substr($file_data,strpos($file_data,'__')+2);

                                // next data is digits__username.wav that we don't need
                                $file_data = substr($file_data,strpos($file_data,'--')+2);

                                // get the duration
                                $duration = substr($file_data,0,strpos($file_data,'--')).' s';
                                if($duration == ' s') $duration = "N/A"; // the duration is still in testing phase, not implemented on servers yet
                                $file_data = substr($file_data,strpos($file_data,'--')+2);

                                // get the size
                                $size = $file_data; // turn bytes into kilobytes

                                // write data into array
				$recordings[$filepath] = array(
	                                'time' => $time,
                                        'from' => $from,
                                        'to' => $to,
                                        'duration' => $duration,
                                        'size' => $size
				);
			}
			return $recordings;
		}
	}
?>
