<?php
if ($login) {
	echo $this->Html->para(null, "You are logged in as $username. "
		. $this->Html->link(
			"Logout",
			array('controller' => 'calls', 'action' => "logout")
		)
	);

	echo $this->Html->para(null, $this->Html->link(
		"Back to folders",
		array('controller' => 'users', 'action' => "login/1")
	));
	?>
	<table>
		<?php
		$max_lines = 30; // max lines per page
		$pages = ceil($recordings['count'] / $max_lines); // total pages
		unset($recordings['count']); // need to unset this index to avoid problems in the next foreach

		// pagination
		if ($cur_page != 1) {
			echo $this->Html->link(
				"<<",
				array('controller' => 'calls', 'action' => "recordings/$cur_date/1")
			);
			echo "&nbsp;";
			echo $this->Html->link(
				"<",
				array('controller' => 'calls', 'action' => "recordings/$cur_date/" . ($cur_page - 1))
			);
			echo "&nbsp;";
		}
		for ($page = 1; $page <= $pages; $page++) {
			if ($page != 1) echo "&nbsp;";
			if ($page == $cur_page) echo $page;
			else echo $this->Html->link(
				$page,
				array('controller' => 'calls', 'action' => "recordings/$cur_date/$page")
			);
		}
		if ($cur_page != $pages) {
			echo "&nbsp;";
			echo $this->Html->link(
				">",
				array('controller' => 'calls', 'action' => "recordings/$cur_date/" . ($cur_page + 1))
			);
			echo "&nbsp;";
			echo $this->Html->link(
				">>",
				array('controller' => 'calls', 'action' => "recordings/$cur_date/$pages")
			);
		}

		// table
		echo $this->Html->tableHeaders(array('#', 'Time', 'From', 'To',/*'Duration',*/
			'Size', 'Download options'));

		/*	We are getting the correct recordings per page from the API, no need to check this anymore
                $i = -1; // index counter
                $start_index = $max_lines * ($cur_page - 1); // 0, 30, 60, ...
                $end_index = ($max_lines * $cur_page) - 1; // 29, 59, 89, ...
                if($end_index > count($recordings)-1) $end_index = count($recordings) - 1; // if there arent 30 entries for $cur_page, set $end_index to $recordings last index
        */
		krsort($recordings); // we want newest entries on top
		$line = 0; // current line
		foreach ($recordings AS $filename => $data) {
			/*			$i++;
                        if($i < $start_index) continue; // we haven't reached first index for our page
                        if($i > $end_index) break; // we have reached last index for our page
            */
			$line++;
			$time = $data['time'];
			$from = $data['from'];
			$to = $data['to'];
			$duration = $data['duration'];
			$size = $data['size'];

			// file size
			$unit = 'B';
			while (strlen(round($size)) > 3) {
				$size /= 1024;
				if ($unit == 'B') $unit = 'kB';
				elseif ($unit == 'kB') $unit = 'MB';
				elseif ($unit == 'MB') {
					$unit = 'GB';
					break;
				} // we don't go higher than GB (which shouldn't ever happen anyway)
			}

			// download options
			$download = $this->Html->link(
				'Download, keep on server',
				array('controller' => 'calls', 'action' => 'download/0/' . urlencode($filename)),
				array('target' => '_blank')
			);
			if (ALLOWDELETE) {
				$download .= " | " . $this->Html->link(
						'Download, delete on server',
						array('controller' => 'calls', 'action' => 'download/1/' . urlencode($filename)),
						array('target' => '_blank')
					);
			}

			echo $this->Html->tableCells(array(array($line, $time, $from, $to,/*$duration,*/
				round($size, 2) . " $unit", $download)));
		}
		?>
	</table>
	<?php
} else {
	$url = $this->Html->url('/calls', array('fullBase' => true));
	header('Refresh: 3; URL=' . $url);
	?>
	<p><?php echo $invalid_login; ?></p>
	<?php
}
?>
