<?php
require_once (__DIR__.'/../Config/AppSettings.php');

function getPaths($path, $first_call = true)
{
	$files = array();
	$temp = array();
	if (is_dir($path)) {
		$globs = glob("$path/*");
		foreach ($globs AS $folder) {
			$id = '';
			$folder_path = explode(RECPATH, $path);
			$folder_path = str_replace('~', '#AUTO#', $folder_path[1]);
			$folder_path = str_replace('/', '~', $folder_path);
			if (is_dir($folder)) {
				$temp[] = getPaths($folder, false);
			} else {
				$file_path = explode('__', str_replace('~', '#AUTO#', $folder));
				$filename_start = explode('/', $file_path[0]);
				$filename_end = '__' . $file_path[1] . '__' . $file_path[2] . '__' . $file_path[3];
				$id = "$folder_path~" . $filename_start[count($filename_start) - 1] . $filename_end;//.'--'.$duration.'--'.$size;
			}

			if ($id != '') $temp[] = $id;
		}

		foreach ($temp AS $subfolder) {
			if (!is_array($subfolder)) {
				$files[] = $subfolder;
			} else {
				foreach ($subfolder AS $file) {
					if (!is_array($file)) $files[] = $file;
				}
			}
		}

		if ($first_call && isset($_GET['page'])) {
			$page = $_GET['page']; // current page on webinterface
			$max_lines = 30; // max lines per page on webinterface
			$start_index = $max_lines * ($page - 1); // 0, 30, 60, ...
			$end_index = ($max_lines * $page) - 1; // 29, 59, 89, ...
			if ($end_index > count($files) - 1) $end_index = count($files) - 1; // if there arent 30 entries for this page, set $end_index to last $files index
			for ($i = $start_index; $i <= $end_index; $i++) {
				// reconstruct file path
				$file = RECPATH;
				$file_path = str_replace('~', '/', $files[$i]);
				$file_path = str_replace('#AUTO#', '~', $file_path);
				$username = substr($file_path, 0, strpos($file_path, '/'));
				$file .= $file_path . "__$username.wav";

				// get file size and duration
				$size = filesize($file);
				$cmd = "sox " . $file . " -n stat 2>&1 | grep seconds";
				$duration = `$cmd`;
				$duration = str_replace("Length (seconds):", "", $duration);
				$duration = trim($duration);
				$duration = substr($duration, 0, strpos($duration, '.'));

				// send size and duration to webinterface
				$files[$i] = $files[$i] . '--' . $duration . '--' . $size;
			}
		}

		return $files;
	} else {
		$file_path = explode(RECPATH, $path);
		$file_path = str_replace('~', '#AUTO#', $file_path[1]);
		$file_path = str_replace('/', '~', $file_path);
		$fileparts = explode('__', $file_path);
		$files[] = $fileparts[0] . '__' . $fileparts[1] . '__' . $fileparts[2] . '__' . $fileparts[3];//.'--'.$duration.'--'.$size;
		if ($first_call && isset($_GET['page'])) {
			$page = $_GET['page']; // current page on webinterface
			$max_lines = 30; // max lines per page on webinterface
			$start_index = $max_lines * ($page - 1); // 0, 30, 60, ...
			$end_index = ($max_lines * $page) - 1; // 29, 59, 89, ...
			if ($end_index > count($files) - 1) $end_index = count($files) - 1; // if there arent 30 entries for this page, set $end_index to last $files index
			for ($i = $start_index; $i <= $end_index; $i++) {
				// reconstruct file path
				$file = RECPATH;
				$file_path = str_replace('~', '/', $files[$i]);
				$file_path = str_replace('#AUTO#', '~', $file_path);
				$username = substr($file_path, 0, strpos($file_path, '/'));
				$file .= $file_path . "__$username.wav";

				// get file size and duration
				$size = filesize($file);
				$cmd = "sox " . $file . " -n stat 2>&1 | grep seconds";
				$duration = `$cmd`;
				$duration = str_replace("Length (seconds):", "", $duration);
				$duration = trim($duration);
				$duration = substr($duration, 0, strpos($duration, '.'));

				// send size and duration to webinterface
				$files[$i] = $files[$i] . '--' . $duration . '--' . $size;
			}
		}

		return $files;
	}
}

function downloadCalls($file, $username)
{
	$file = explode('--', $file);
	$file = str_replace('~', '/', $file[0]) . "__$username.wav";
	$file = str_replace('#AUTO#', '~', $file);
	header('Content-Description: File Transfer');
	header("Content-Type: audio/wave");
	header('Content-Disposition: attachment; filename=' . basename($file));
	header('Content-Transfer-Encoding: binary');
	header('Content-Length: ' . filesize($file));
	ob_clean();
	flush();
	readfile($file);
	exit;
}

function deleteCalls($file, $username)
{
	if(ALLOWDELETE) {
		$file = explode('--', $file);
		$file = str_replace('~', '/', $file[0]) . "__$username.wav";
		$file = str_replace('#AUTO#', '~', $file);
		if (is_dir($file)) {
			echo "$file is not a file!\n";
		} else {
			if (file_exists($file)) unlink($file);
			else echo "$file does not exist!\n";
		}
	}else
		echo 'Deletion of the files is disabled';
}

function getFolders($path)
{
	$folders = array();
	$globs = glob("$path/*");
	foreach ($globs AS $folder) if (is_dir($folder))
		if (glob("$folder/*")) { // make sure folder isn't empty
			// get rid of path to folder
			$date = substr($folder, strrpos($folder, '/') + 1);

			// get folder size
			$io = popen('/usr/bin/du -sk ' . $folder, 'r');
			$size = fgets($io, 4096);
			$size = substr($size, 0, strpos($size, "\t"));

			$folders[$date] = $size;
		}
	return $folders;
}

function getFiles($folder, $page)
{
	$files = array();
	$maxlines = 30;
	$start = $maxlines * ($page - 1); // 0, 30, 60, ...
	$end = ($maxlines * $page) - 1; // 29, 59, 89, ...
	$globs = glob("$folder/*");
	$cur_file = -1;
	rsort($globs);
	foreach ($globs AS $file) {
		$cur_file++;
		if ($cur_file < $start || $cur_file > $end) continue; // we don't need any details about these files for this page, but we need the count

		// get file size and duration
		$size = filesize($file);
		$cmd = "sox " . $file . " -n stat 2>&1 | grep seconds";
		/*		sox is too slow to implement this
                    $duration = `$cmd`;
                    $duration = str_replace("Length (seconds):","",$duration); $duration = trim($duration);
                    $duration = substr($duration,0,strpos($duration,'.'));
        */
		$duration = '';
		$files[] = str_replace(RECPATH, '', $file) . "--" . $duration . "--" . $size;
	}
	$files['count'] = $cur_file + 1; // $cur_file starts at 0
	return $files;
}

function getFile($path, $calluid, $action)
{
	$globs = glob("$path/*/*"); // path/date/filename
	$found = false;
	foreach ($globs AS $filepath) {
		$fileparts = explode('__', $filepath); // /absoulte/path/username/date/time__from__to__calluid__username.wav
		$filecalluid = $fileparts[count($fileparts) - 2];
		if ($filecalluid == $calluid) {
			$found = true;
			break;
		}
	}

	if ($found) {
		// we need the file path in format username/date/time__from__to__calluid
		// in order to use existing API functions to download/delete the call
		$file = $fileparts[0];
		for ($i = 1; $i < count($fileparts) - 1; $i++) $file .= '__' . $fileparts[$i];
		$username = substr($fileparts[count($fileparts) - 1], 0, strpos($fileparts[count($fileparts) - 1], '.'));
		switch ($action) {
			case "download":
				downloadCalls($file, $username);
				break;
			case "delete":
				deleteCalls($file, $username);
				break;
		}
	} else echo "calluid $calluid was not found for the given user.";
}

if (!isset($_GET['username']) || !isset($_GET['password']) || !isset($_GET['action'])) {
	echo "Missing parameters:\n";
	echo (!isset($_GET['username'])) ? "    username\n" : '';
	echo (!isset($_GET['password'])) ? "    password\n" : '';
	echo (!isset($_GET['action'])) ? "    action\n" : '';
	exit;
} else {
	$username = $_GET['username'];
	$password = $_GET['password'];
	$action = $_GET['action'];

	$path = RECPATH;
	$dir = $username;

	if (RECPASSWORD == $password && RECUSER == $username) {
		if (isset($_GET['calluid'])) {
			switch ($action) {
				case "delete":
					getFile($path . $username, $_GET['calluid'], 'delete');
					break;
				case "download":
				default:
					getFile($path . $username, $_GET['calluid'], 'download');
			}
		} else {
			switch ($action) {
				case "index":
					echo json_encode(getPaths($path . $username));
					break;
				case "get":
					echo json_encode(getPaths($path . $username));
					break;
				case "download":
					if (strstr($_GET['file_id'], '.') || strstr($_GET['file_id'], '/')) echo ". and / are not allowed!";
					else downloadCalls($path . $_GET['file_id'], $username);
					break;
				case "delete":
					if (strstr($_GET['file_id'], '.') || strstr($_GET['file_id'], '/')) echo ". and / are not allowed!";
					else deleteCalls($path . $_GET['file_id'], $username);
					break;
				case "getfolders":
					echo json_encode(getFolders($path . $username));
					break;
				case "getfiles":
					if (strstr($_GET['date'], '.') || strstr($_GET['date'], '/')) echo ". and / are not allowed!";
					else echo json_encode(getFiles($path . $username . '/' . $_GET['date'], $_GET['page']));
					break;
				default:
					echo json_encode("'$action' is not a valid action!\n");
			}
		}
	} else {
		echo "Username and password do not match!";
	}
}
?>
